import {
  Controller,
  Post,
  Delete,
  Route,
  Security,
  Tags,
  Body,
  Path,
  Request,
  Get,
  Patch,
  Put,
} from "tsoa";
import { Not } from "typeorm";
import HttpSuccess from "../interfaces/http-success";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import {
  ProfileEducation,
  CreateProfileEducation,
  UpdateProfileEducation,
} from "../entities/ProfileEducation";
import { RequestWithUser } from "../middlewares/user";
import { Profile } from "../entities/Profile";
import { ProfileEducationHistory } from "../entities/ProfileEducationHistory";
import { AppDataSource } from "../database/data-source";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile/educations")
@Tags("ProfileEducations")
@Security("bearerAuth")
export class ProfileEducationsController extends Controller {
  private profileRepo = AppDataSource.getRepository(Profile);
  private profileEducationRepo = AppDataSource.getRepository(ProfileEducation);
  private profileEducationHistoryRepo = AppDataSource.getRepository(ProfileEducationHistory);

  @Get("user")
  public async detailProfileEducationUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const getProfileEducation = await this.profileEducationRepo.find({
      where: { profileId: profile.id, isDeleted: false },
      order: { level: "ASC" },
    });
    if (!getProfileEducation) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileEducation);
  }

  @Get("{profileId}")
  public async detailProfileEducation(@Path() profileId: string, @Request() req: RequestWithUser) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_OFFICER");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_OFFICER", profileId);
    const getProfileEducation = await this.profileEducationRepo.find({
      where: { profileId: profileId, isDeleted: false },
      order: { level: "ASC" },
    });
    if (!getProfileEducation) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileEducation);
  }

  @Get("admin/history/{educationId}")
  public async getProfileEducationAdminHistory(
    @Path() educationId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, educationId, "SYS_REGISTRY_OFFICER");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_OFFICER", _record.profileId);
    }
    const record = await this.profileEducationHistoryRepo.find({
      where: {
        profileEducationId: educationId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Get("history/{educationId}")
  public async getProfileEducationHistory(@Path() educationId: string) {
    const record = await this.profileEducationHistoryRepo.find({
      where: {
        profileEducationId: educationId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Post()
  public async newProfileEducation(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEducation,
  ) {
    if (!body.profileId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepo.findOneBy({ id: body.profileId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_OFFICER", profile.id);
    if (body.isEducation) {
      await this.profileEducationRepo.update(
        { profileId: body.profileId, isEducation: true },
        { isEducation: false },
      );
    }
    if (body.isHigh) {
      await this.profileEducationRepo.update(
        { profileId: body.profileId, isHigh: true },
        { isHigh: false },
      );
    }
    const before = null;
    const data = new ProfileEducation();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileEducationHistory();
    Object.assign(history, { ...data, id: undefined });

    const education = await this.profileEducationRepo.findOne({
      select: ["id", "level", "profileId"],
      where: { profileId: body.profileId },
      order: { level: "DESC" },
    });
    data.level = education == null ? 1 : education.level + 1;
    await this.profileEducationRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileEducationId = data.id;
    await this.profileEducationHistoryRepo.save(history, { data: req });
    //setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{educationId}")
  public async editProfileEducation(
    @Body() body: UpdateProfileEducation,
    @Request() req: RequestWithUser,
    @Path() educationId: string,
  ) {
    const record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_OFFICER", record.profileId);
    if (body.isEducation) {
      await this.profileEducationRepo.update(
        { profileId: record.profileId, isEducation: true, id: Not(educationId) },
        { isEducation: false },
      );
    }
    if (body.isHigh) {
      await this.profileEducationRepo.update(
        { profileId: record.profileId, isHigh: true, id: Not(educationId) },
        { isHigh: false },
      );
    }
    const before = structuredClone(record);
    // const before_null = null;
    const history = new ProfileEducationHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileEducationId = educationId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.profileEducationRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileEducationHistoryRepo.save(history, { data: req }),
      // setLogDataDiff(req, { before: before_null, after: history }),
    ]);

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลประวัติการศึกษา
   * @summary API ลบข้อมูลประวัติการศึกษา/ดูงาน
   * @param educationId คีย์ประวัติการศึกษา
   */
  @Patch("update-delete/{educationId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() educationId: string,
  ) {
    const record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_OFFICER", record.profileId);
    const before = structuredClone(record);
    const history = new ProfileEducationHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileEducationId = educationId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.profileEducationRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileEducationHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{educationId}")
  public async deleteProfileEducation(
    @Path() educationId: string,
    @Request() req: RequestWithUser,
  ) {
    const record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (record) {
      await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_OFFICER", record.profileId);
    }
    await this.profileEducationHistoryRepo.delete({
      profileEducationId: educationId,
    });

    const result = await this.profileEducationRepo.delete({ id: educationId });

    if (result.affected == undefined || result.affected <= 0)
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    const education = await this.profileEducationRepo.find({
      select: ["id", "level", "profileId"],
      where: { profileId: record?.profileId },
      order: { level: "ASC" },
    });

    const sortLevel = education.map((data, i) => ({
      id: data.id,
      level: i + 1,
    }));
    await this.profileEducationRepo.save(sortLevel);

    return new HttpSuccess();
  }

  /**
   * API จัดลำดับแสดงประวัติการศึกษา
   *
   * @summary ORG_038 - จัดลำดับแสดงประวัติการศึกษา (ADMIN) #
   *
   */
  @Put("sort/{profileId}")
  async Sort(
    @Path() profileId: string,
    @Body() requestBody: { data: { id: string; isUse: boolean }[] },
  ) {
    const profile = await this.profileRepo.findOne({
      where: { id: profileId },
    });
    if (!profile) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบ profile ดังกล่าว");
    }

    const education = await this.profileEducationRepo.find({
      // select: ["id", "level", "profileId", "isUse"],
      where: { profileId: profileId },
    });

    const sortLevel = education.map((data) => ({
      ...data,
      id: data.id,
      level: requestBody.data.findIndex((x) => x.id == data.id) + 1,
      isUse: requestBody.data.find((x) => x.id == data.id)?.isUse ?? false,
    }));

    await this.profileEducationRepo.save(sortLevel);
    return new HttpSuccess();
  }
}
